自学内容网 自学内容网

代码随想录——打家劫舍(Leetcode198)

题目链接
在这里插入图片描述

背包问题

class Solution {
    public int rob(int[] nums) {
        if(nums.length == 0){
            return 0;
        }
        if(nums.length == 1){
            return nums[0];
        }
        int[] dp = new int[nums.length];
        dp[0] = nums[0];
        dp[1] = Math.max(nums[0], nums[1]);
        for(int i = 2; i < nums.length; i++){
            dp[i] = Math.max(dp[i - 1], dp[i - 2] + nums[i]);
        }
        return dp[nums.length - 1];
    }
}

对于第i间房屋,你有两种选择:

  • 偷窃第i间房屋,那么你不能偷窃第i-1间房屋,所以总金额是dp[i-2] + nums[i]。
  • 不偷窃第i间房屋,那么总金额是dp[i-1]。
    因此,状态转移方程为:dp[i] = max(dp[i-1], dp[i-2] + nums[i])

原文地址:https://blog.csdn.net/qq_46574748/article/details/140624703

免责声明:本站文章内容转载自网络资源,如本站内容侵犯了原著者的合法权益,可联系本站删除。更多内容请关注自学内容网(zxcms.com)!